//#include "colors.inc"
//#include "textures.inc"
//#include "shapes.inc"
#include "parts.inc"
camera
 {  location  <  0.0       4.0     -13.5>
    direction <  0.0       0.0       1.0>
    up        <  0.0       1.0       0.0>
    right     <  1.33333   0.0       0.0>
    look_at   <  0         5         0  >
 }
//--- light source
object
 { light_source  { < -10 20 -30 > color White } }

fog {
    color White
    80000.0
    }

/*The Sky*/
object { quadric { Ellipsoid
   scale <50000.0 50000.0 100000.0>
   translate <0 -40000 0>
   texture { 
      0.05 
      Bright_Blue_Sky
      scale <8000.0 3000.0 8000.0>
      ambient 0.6
      diffuse 0.0
   } // end of texture
 } // end of Ellipsoid
   colour Blue
} // end of quadric object


#declare Lozenge = 
  quadric {
   <1.0 1.0 1.0>
   <0.0 0.0 0.0>
   <0.0 0.0 0.0>
  -1.0
   }

//--- shell object
#declare Shell =
object
   { quadric { Ellipsoid
   scale <3.175 4.175 3.175>
   translate <0 4 0>
   texture
   { Bright_Blue_Sky
     turbulence  0.4
     phong       1
     phong_size 80
     reflection  0.1
     color_map {
        [0.0 0.3 color Black color DarkOliveGreen]
        [0.3 0.5 color DarkOliveGreen color DarkGreen]
        [0.5 1.0 color DarkGreen color Green]
        }
     scale < 2 2 2 > } // end of texture
     } // end of Ellipsoid
     clipped_by { 
        quadric { Cylinder_Y  scale <3 1 3> translate <-2.5 0 0> inverse }
     } // end of clipped_by
     rotate <0 -150 0>
 } // end of quadric object
      
#declare Belly =
object
   { quadric { Ellipsoid
   scale <3 4 3>
   translate <0 4 0>
       texture { image_map { gif "reptile.gif" map_type 0 }
       scale <10 10 10>
       rotate <0 20 0> }
   rotate <0 -150 0>
 } // end of quadric object
}      

#declare Main_Belt =
object
   { quadric { Ellipsoid
   scale <3.001 4.000 3.001>
   translate <0 4 0>
   texture { Phong_Dull color Black }
 } // end of quadric object
}      

#declare Limb = object { quadric { Ellipsoid } }

#declare Eyelid =
object {
   sphere { <0 0 0> 0.153
      texture { image_map { gif "x_reptil.gif" map_type 0 }
         brilliance 3.0
         phong 1.0
         scale <8 8 8>
         rotate <0 20 0> 
              } 
         }
     }

#declare Eyeball =
object {
   sphere { <0 0 0> 0.15
            texture { Phong_Dull color White }
          }
        }

#declare Iris =
object {
   sphere { <0 0 -0.08> 0.1
            texture { Phong_Dull color Black }
          }
        }

#declare Eye =
composite {
   object { Eyeball }
   object { Iris    }
          }

#declare Fish = 
composite {
   object { quadric { Ellipsoid 
     scale <1.25 0.5 0.2>
     rotate <0 0 15>
     texture { image_map { gif "x_reptil.gif" map_type 0 }
        brilliance 3.0
        phong 1.0
        scale <10 10 10>
        rotate <0 20 0> } } }
   composite { Eye rotate    <0 -45.0 0>
                   rotate    <0 0 30>
                   translate <0.5 0.25 -0.1> }
   composite { Eye rotate    <180 0 0>
                   rotate    <0  45.0 0> 
                   rotate    <0 0 30>
                   translate <0.5 0.25  0.1> }
 }

#declare Cranium =
object {
   quadric {
      Ellipsoid
      scale <1.85 2.5 1.85>
      rotate <0 0 20>
      translate <2 8.3 -1>
      texture { image_map { gif "reptile.gif" map_type 0 } scale <10 10 10> }
      }
   }

#declare Strap =
object {
   quadric {
      Ellipsoid
      scale <1.9 2.55 1.9>
      rotate <0 0 20>
      translate <2 8.3 -1>
      texture { Phong_Dull color Orange }
           } // end of quadric
      clipped_by { 
         plane { <0 1 0> 8.8 }
         plane { <0 1 0> 8.5 inverse } 
                 } // end of clipped_by
        } // end of object

#declare Goggle =
object {
   quadric {
      Cylinder_X
      scale <1 0.75 0.75>
      translate <2 8.65 -2>
      texture { Phong_Dull color Orange }
      }
      clipped_by {
         plane { <1 0 0> 3.85 }
         plane { <1 0 0> 1.5 inverse }
      } 
  }

#declare Spear =
object {
   quadric {
      Cylinder_Y
      scale <0.095 1 0.095>
      translate <4 7.6 -3>
      texture { Brass_Metal
          brilliance 3.0
          phong 1.0 }
      }
      clipped_by {
         plane { <0 1 0> 8.0 }
         plane { <0 1 0> 0.5 inverse }
         } 
  }

#declare Half_Barb =
object {
   plane { <0 0 1> 0 }
   texture { Brass_Metal
      reflection 0.3
      brilliance 3.0
      phong 1.0  }
   clipped_by {
      plane { <0 1 0> 0 }
      quadric { Paraboloid_X
         rotate <0 0 30>
         translate <0 -0.5 0> }
      plane { <0 0 1> 1 }
      }
}

#declare Barb =
composite {
   object { Half_Barb rotate <-3 0 0> }
   object { Half_Barb rotate <180 0 0> }
          }



#declare Snorkel =
object {
   quadric {
      Cylinder_Y
      scale <0.3 1 0.3>
      texture { Phong_Dull color Orange }
   }
      clipped_by {
         plane { <0 1 0> 4 }
         plane { <0 1 0> 0 inverse }
      }

}
#declare Abdomen =
object
   { quadric { Ellipsoid
     scale <3 4 3>
     translate <0 4 0>
        texture { image_map { gif "shorts.gif" map_type 0 }
        scale <10 10 10>
        rotate <0 20 0> }
   }  rotate <0 105 0> // end of Ellipsoid
} // end of quadric


#declare Midriff =
object {
  quartic {
     < 1.0   0.0  0.0  0.0  2.0  0.0    0.0  2.0    0.0
     -104.0  0.0  0.0  0.0  0.0  0.0    0.0  0.0    0.0
        0.0  0.0  1.0  0.0  0.0  2.0    0.0  56.0   0.0
        0.0  0.0  0.0  1.0  0.0 -104.0  0.0  784.0 >
//        scale <0.3 0.3 0.3>
//        texture { image_map { gif "reptile.gif" map_type 3 once } }
        }
        bounded_by {
           sphere { <0.0 0.0 0.0> 10 }
        }
}

#declare Bulge =
object {
  quartic {
     < 1.0   0.0  0.0  0.0  2.0  0.0    0.0   2.0    0.0
    -104.0   0.0  0.0  0.0  0.0  0.0    0.0   0.0    0.0
       0.0   0.0  1.0  0.0  0.0  2.0    0.0  56.0    0.0
       0.0   0.0  0.0  1.0  0.0 -104.0  0.0  784.0 >
          texture { image_map { gif "shorts.gif" map_type 0 }
          scale <10 10 10>
          rotate <0 20 0> } 
          }
          bounded_by {
             sphere { <0.0 0.0 0.0> 10 }
          }
}


#declare Front =
composite {
object { Belly }
object { Midriff scale <0.305 0.305 0.305>  translate  <0 3 0> 
   texture { image_map { gif "reptile.gif" map_type 0 }
   scale <10 10 10>
   rotate <0 20 0> } }
object { Midriff scale <0.32 0.32 0.32> translate <0 3.8 0> 
   texture { image_map { gif "reptile.gif" map_type 0 }
   scale <10 10 10> 
   rotate <0 20 0> } }
object { Midriff scale <0.314 0.314 0.314> translate <0 4.79 0>
   texture { image_map { gif "reptile.gif" map_type 0 }
   scale <10 10 10>
   rotate <0 20 0> } }
}

#declare Belt =
composite {
object { Main_Belt }
object { Midriff scale <0.306 0.306 0.306>  translate  <0 3 0> 
   texture { Phong_Dull color Black } }
object { Midriff scale <0.321 0.321 0.321> translate <0 3.8 0> 
   texture { Phong_Dull color Black } }
object { Midriff scale <0.315 0.315 0.315> translate <0 4.79 0>
   texture { Phong_Dull color Black } }
}

#declare Trunks =
composite {
object { Abdomen }
object { Bulge scale <0.32 0.32 0.32> translate <0 3.8 0> }
object { Bulge scale <0.305 0.305 0.305> translate <0 3 0> }
          }

#declare Torso =
composite { 
      Front
      clipped_by {
         plane { <0 1 0> 2 
         rotate <0 0 30>
         rotate <0 30 0> inverse
//         texture { image_map { gif "reptile.gif" map_type 1 once } }
    }
  }
}

#declare Belt2 =
composite { 
      Belt
      clipped_by {
         plane { <0 1 0> 2.15
         rotate <0 0 30>
         rotate <0 30 0> }
         plane { <0 1 0> 2.02
         rotate <0 0 30>
         rotate <0 30 0> inverse }
                 }
          }

#declare Trunks2 =
   composite {
      Trunks 
      clipped_by {
         plane { <0 1 0> 2
         rotate <0 0 30> 
         rotate <0 30 0> 
         texture { image_map { gif "shorts.gif" map_type 0 }
            scale <10 10 10> 
            rotate <0 20 0> }
         } // end of plane
      } // end of clipped_by
   } // end of composite

#declare Water =
object { // The water
   sphere { <0.0  -6400000.0  0.0> 6400000.75 }
   texture {
      turbulence 0.17
      colour SeaGreen
      ripples 0.35
      frequency 100.0
      ambient 0.1
      diffuse 0.1
      reflection 0.65
      specular 0.5
      roughness 0.03
      scale <700.0 700.0 700.0>
   }
}

object    { Water }

#declare Turtle =
composite {
composite { Torso }
composite { Trunks2 }
composite { Belt2 }
object    { Shell }
object    { Cranium }
object    { Strap }
object    { Goggle }
/*
composite { Upper_Arm 
     rotate    <0 30 0>
     translate <1 6.2 -2.8> }
composite { Upper_Arm
     rotate    <0 25 0>
     translate <1 3.86 -3.17> }
*/
object { quadric { Lozenge 
     rotate <0 45 0>
     translate <0.3 6.2 -2.0>
       texture { image_map { gif "reptile.gif" map_type 0 }
       scale <10 10 10>
       rotate <0 -20 0> }
 } }

object { Limb 
     scale <1.5 1.0 0.25>
     rotate <0 0 45>
     translate <0.5 6.2 -2.6>
       texture { image_map { gif "reptile.gif" map_type 0 }
       scale <10 10 10>
       rotate <0 20 0> }
 } 

object { Limb 
     scale <1.25 0.75 0.2>
     rotate <0 0 30>
     rotate <0 15 0>
     translate <2.55 6.3 -3.4>
     texture { image_map { gif "reptile.gif" map_type 0 } scale <10 10 10> }
 } 

object { Limb 
     scale <1.25 0.95 0.2>
     translate <1.75 6.4 -3.1>
     texture { image_map { gif "reptile.gif" map_type 0 } scale <10 10 10> }
 } 

object { Snorkel translate <3.5 9.5 3> }

} // end of Turtle

//composite { Fish rotate    <0 45 0>
//                 translate < -1 5 -9 > }

composite { Fish translate < -4.5 0.73 -4.0 > }
composite { Fish rotate    < 0 30 0 >
                 translate < -5.0 0.65 0 > }
composite { Fish rotate    < 0 25 0 >
                 translate < -6.0 0.6 -2.0 > }

composite { Turtle rotate <0 0 -40> translate <-2.5 2.0 0.0> }
composite { Bottom_Half }
object    { Spear }
composite { Barb 
            scale     <0.3 0.3 1> 
            rotate    <0   0  90>
            translate <4   8  -3> }
// object { plane { <1 0 0> 20 rotate <0 35 0> } }

